unit AreaF;

interface 

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Placemnt, Menus, SpeedBar,
  RXSplit, Grids, StdCtrls, Buttons,

  Radio,
  Commands,
  Mail, ComCtrls, IPopup;

const
  HeaderWidthKey = 'HeaderWidth%d';

type
  TShowKind = (skSimpleTree, skUnreadsAndTheirParentsTree, skList);

type
  TAreaForm = class(TForm)
    SpeedBar: TSpeedBar;
    PreviousLetterSpeedItem: TSpeedItem;
    NextLetterSpeedItem: TSpeedItem;
    PreviousUnreadLetterSpeedItem: TSpeedItem;
    NextUnreadLetterSpeedItem: TSpeedItem;
    PreviousConversationSpeedItem: TSpeedItem;
    NextConversationSpeedItem: TSpeedItem;
    PreviousUnreadConversationSpeedItem: TSpeedItem;
    NextUnreadConversationSpeedItem: TSpeedItem;
    SimpleTreeSpeedItem: TSpeedItem;
    ListSpeedItem: TSpeedItem;
    SpeedBarPopupMenu: TPopupMenu;
    ConfigureItem: TMenuItem;
    ShowHintItem: TMenuItem;
    HideSpeedBar: TMenuItem;
    SpeedBarHelpItem: TMenuItem;
    MainMenu: TMainMenu;
    BrowseItem: TMenuItem;
    TreeExitItem: TMenuItem;
    ExpandOneLevelItem: TMenuItem;
    ExpandBranchItem: TMenuItem;
    ExpandAllItem: TMenuItem;
    CollapseBranchItem: TMenuItem;
    CollapseAllItem: TMenuItem;
    N9: TMenuItem;
    SimpleTreeItem: TMenuItem;
    ListItem: TMenuItem;
    ListOrTreeItem: TMenuItem;
    SwitchItem: TMenuItem;
    SpeedBarItem: TMenuItem;
    StatusLineItem: TMenuItem;
    NavigationItem: TMenuItem;
    N2: TMenuItem;
    PreviousLetterItem: TMenuItem;
    NextLetterItem: TMenuItem;
    N10: TMenuItem;
    PreviousUnreadLetterItem: TMenuItem;
    PreviousUnreadLetterItem2: TMenuItem;
    NextUnreadLetterItem: TMenuItem;
    NextUnreadLetterItem2: TMenuItem;
    N1: TMenuItem;
    PreviousConversationItem: TMenuItem;
    NextConversationItem: TMenuItem;
    N99: TMenuItem;
    PreviousUnreadConversationItem: TMenuItem;
    NextUnreadConversationItem: TMenuItem;
    N6: TMenuItem;
    GotoRootItem: TMenuItem;
    FormStorage: TFormStorage;
    UpOneLevelItem: TMenuItem;
    Bevel1: TBevel;
    WindowsItem: TMenuItem;
    SwitchToTopEditor: TMenuItem;
    SwitchToAreasItem: TMenuItem;
    WindowListItem: TMenuItem;
    N12: TMenuItem;
    HelpItem: TMenuItem;
    ContentsItem: TMenuItem;
    SearchforHelpOnItem: TMenuItem;
    HowtoUseHelpItem: TMenuItem;
    AboutItem: TMenuItem;
    LevelUpSpeedItem: TSpeedItem;
    LevelDownSpeedItem: TSpeedItem;
    DownOneLevelItem: TMenuItem;
    GotoRootSpeedItem: TSpeedItem;
    UnreadsAndTheirParentsTreeItem: TMenuItem;
    UnreadsAndTheirParentsTreeSpeedItem: TSpeedItem;
    SetCurrent: TTimer;
    OneLevelItem: TMenuItem;
    ThisLevelItem: TMenuItem;
    ThisLevelDownItem: TMenuItem;
    ThisLevelUpItem: TMenuItem;
    N4: TMenuItem;
    LetterItem: TMenuItem;
    ReplyItem: TMenuItem;
    NewItem: TMenuItem;
    CommentItem: TMenuItem;
    N11: TMenuItem;
    NewSpeedItem: TSpeedItem;
    ReplySpeedItem: TSpeedItem;
    CommentSpeedItem: TSpeedItem;
    N7: TMenuItem;
    ReplyInAnotherAreaItem: TMenuItem;
    CommentInAnotherAreaItem: TMenuItem;
    ReplyInAnotherAreaSpeedItem: TSpeedItem;
    CommentInAnotherAreaSpeedItem: TSpeedItem;
    ChangeSpeedItem: TSpeedItem;
    ChangeItem: TMenuItem;
    DeleteItem: TMenuItem;
    N13: TMenuItem;
    DeleteSpeedItem: TSpeedItem;
    DoFind: TTimer;
    N14: TMenuItem;
    BrowsePanel: TPanel;
    LetterPanel: TPanel;
    rxSplitter1: TrxSplitter;
    N8: TMenuItem;
    KludgesItem: TMenuItem;
    LetterBrowseSwitchItem: TMenuItem;
    N15: TMenuItem;
    ViewerPopupMenu: TPopupMenu;
    N5: TMenuItem;
    N17: TMenuItem;
    N19: TMenuItem;
    N20: TMenuItem;
    N22: TMenuItem;
    N24: TMenuItem;
    OptionsItem: TMenuItem;
    UserItem: TMenuItem;
    KludgesSpeedItem: TSpeedItem;
    ThisLevelUpSpeedItem: TSpeedItem;
    ThisLevelDownSpeedItem: TSpeedItem;
    Panel7: TPanel;
    ScrollBox: TScrollBox;
    Viewer: TDrawGrid;
    Panel8: TPanel;
    HeaderPanel: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    DateTimeWritten: TLabel;
    DateTimeArrived: TLabel;
    SubjectLabel: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    ToLabel: TLabel;
    FromLabel: TLabel;
    Tree: TTreeView;
    Panel1: TPanel;
    ImageList: TImageList;
    StatusBar: TStatusBar;
    BrowseIndirectPopupMenu: TIndirectPopupMenu;
    LetterIndirectPopupMenu: TIndirectPopupMenu;
    NavigateIndirectPopupMenu: TIndirectPopupMenu;
    procedure FormStorageRestorePlacement(Sender: TObject);
    procedure FormStorageSavePlacement(Sender: TObject);
    procedure ConfigureItemClick(Sender: TObject);
    procedure ShowHintItemClick(Sender: TObject);
    procedure HideSpeedBarClick(Sender: TObject);
    procedure SpeedBarItemClick(Sender: TObject);
    procedure StatusLineItemClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TreeExitItemClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SwitchToTopEditorClick(Sender: TObject);
    procedure SwitchToAreasItemClick(Sender: TObject);
    procedure HeaderSizing(Sender: TObject; ASection, AWidth: Integer);
    procedure AnyNavigateItemClick(Sender: TObject);
    procedure AnyViewItemClick(Sender: TObject);
    procedure AnyViewSpeedItemClick(Sender: TObject);
    procedure AnyExpandCollapseItemClick(Sender: TObject);
    procedure SetCurrentTimer(Sender: TObject);
    procedure ExpandAllOrCollapseAllItemClick(Sender: TObject);
    procedure TreeKeyPress(Sender: TObject; var Key: Char);
    procedure FormDeactivate(Sender: TObject);
    procedure AnyLetterItemClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure DeleteItemClick(Sender: TObject);
    procedure DoFindTimer(Sender: TObject);
    procedure ViewerDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure KludgesItemClick(Sender: TObject);
    procedure ViewerKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure LetterBrowseSwitchItemClick(Sender: TObject);
    procedure ScrollBoxResize(Sender: TObject);
    procedure KludgesSpeedItemClick(Sender: TObject);
    procedure TreeChange(Sender: TObject; ANode: TTreeNode);
    procedure TreeGetImageIndex(Sender: TObject; Node: TTreeNode);
    procedure TreeGetSelectedIndex(Sender: TObject; Node: TTreeNode);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
    procedure CreateParams(var Params: TCreateParams); override;
  private
    AreaLine, ConversationLine, LetterLine: TStatusPanel;
  private
    procedure UpdateOptions;

    procedure StartStopUpdatingArea;

    procedure CMStartUpdatingArea(var Msg: TRadioMessage);
      message CM_StartUpdatingArea;
    procedure CMStopUpdatingArea(var Msg: TRadioMessage);
      message CM_StopUpdatingArea;

    procedure CurrentLetterChanged;
    procedure CMCurrentLetterChanged(var Msg: TRadioMessage);
      message CM_CurrentLetterChanged;

    procedure CMAreasChanged(var Msg: TRadioMessage);
      message CM_AreasChanged;

    procedure UpdateCaption;
    procedure UpdateAreaLine;

    procedure CMAreaDestroyed(var Msg: TRadioMessage);
      message CM_AreaDestroyed;

    procedure CMAreaCountsChange(var Msg: TRadioMessage);
      message CM_AreaCountsChange;

    {procedure CMNewLetterInserted(var Msg: TRadioMessage);
      message CM_NewLetterInserted;}

    function IterateFunc(Node: TTreeNode): Boolean;
    function HasUnreadDescendants(Node: TTreeNode): Boolean;
    procedure Navigate(Code: Integer; EnteringArea: Boolean);
  private
    FShowKind: TShowKind;
    TotalCount, UnreadCount, JustReadCount: Integer;

    procedure SetShowKind(AShowKind: TShowKind);
    property ShowKind: TShowKind read FShowKind write SetShowKind;

    procedure SelectCurrent;

    function ConversationContainUnreadOrJustReadLettersOrThis(Letter: TLetter;
      InfoPtr: Pointer): Boolean;
    procedure UpdateTree;
{    function CountTotals(Node: TOutlineNode): Boolean;}
    procedure UpdateConversationLine;
  private
    FDelayedCurrent: TLetter;
    function GetDelayedCurrent: TLetter;
    procedure SetDelayedCurrent(ADelayedCurrent: TLetter);
    property DelayedCurrent: TLetter read GetDelayedCurrent write SetDelayedCurrent;
    procedure FlushSetCurrentTimer;
  private
    FIncSearchCount: Integer;
    FIncSearchedStr: string;
    FIncSearchStartNode: TTreeNode;
    FIncSearching: Boolean;
    IncSearchResetBlocked: Boolean;
    DoFindNode: TTreeNode;

    procedure SetIncSearchedStr(const AIncSearchedStr: string);
    procedure SetIncSearching(const AIncSearching: Boolean);

    property IncSearchedStr: string read FIncSearchedStr write SetIncSearchedStr;
    property IncSearching: Boolean read FIncSearching write SetIncSearching;
  private
    GlobalCanClose: Boolean;
    function CloseQuery(FromNavigate: Boolean): Boolean;
  private
    MessageLines: TStringList;
    procedure UpdateViewerWidth;
    procedure UpdateViewerHeight;
    procedure ClearLetter;
  private
    procedure SetViewerWidth(AViewerWidth: Integer);
    property ViewerWidth: Integer write SetViewerWidth;
  private
    procedure ApplicationHint(Sender: TObject);
  private
    procedure UpdateNodeStateByLetter(Letter: TLetter);
  public
    { Public declarations }
    Area: TArea;

    constructor Create(AArea: TArea);
  end;

implementation

{$R *.DFM}
{$R *.RES}

uses
  VCLUtils,
  AppUtils,

  MKGlobT,
  MKString,

  Common,
  TextKind,
  ReFormat,

  EditorF, TreeHU, AREASF;

procedure TAreaForm.CreateParams;
begin
  inherited CreateParams(Params);
{
-     (2:5020/468.8) ------------------ PERSONAL (RU.DELPHI) -
    : Vadim Epmak                         2:5100/79        23  96 10:56
  : Alexander Petrosyan                                 c 25  96 13:12
  : Delphi 2.0:   .EXE/.DLL -  Alt+Tab . ?
--------------------------------------------------------------------------------
 * Forwarded from area 'RU.DELPHI'
[...]
 AP>    ?

       ,      p 
 y     NULL
}
  Params.WndParent := 0
    {   Alt+Tab .
      Vadim Epmak(2:5100/79)  23  96 10:56};
end;

constructor TAreaForm.Create;
begin
  Area := AArea;
  Area.OpenOrCreate{        .
      ,     ?};

  inherited Create(Application);
end;

procedure TAreaForm.UpdateViewerHeight;

  procedure UpdateFonts;
  var
    TypeHeights: array[TTextKind] of Integer;
    I: Integer;
    tk: TTextKind;
  begin
    for tk := Low(TTextKind) to Pred(High(TTextKind)) do
      TypeHeights[tk] := 17{-EnvDialog.Fonts[tk].Height+3};

    with Viewer do
    begin
      for I := 0 to Pred(MessageLines.Count{  RowCount,
           0,  1}) do
        RowHeights[I] := TypeHeights[GetTextKind(MessageLines[I])];
      Invalidate;
    end;
  end;

var
  I: Integer;
  TotalHeight: Integer;
begin
  with Viewer do
  begin
    RowCount := MessageLines.Count;
    UpdateFonts;{ RowHeights}

    TotalHeight := 0;
    for I := 0 to Pred(RowCount) do
      Inc(TotalHeight, RowHeights[I]+1);
    Height := TotalHeight;
    ScrollBox.VertScrollBar.Position := 0;
  end;
end;

procedure TAreaForm.ClearLetter;
begin
  SubjectLabel.Caption := '';

  FromLabel.Caption := '';
  ToLabel.Caption := '';
  DateTimeWritten.Caption := '';

  MessageLines.Clear;
  UpdateViewerHeight;
end;

procedure TAreaForm.FormCreate(Sender: TObject);

  procedure InitViewer;
  begin
    {}DateTimeArrived.Caption := '';

    LetterLine.Text := '';

    with Viewer do
    begin
      Width := 10000;
      Height := 0;
    end;

    MessageLines := TStringList.Create;
  end;

  procedure InitPosition;
  begin
    with Area do
      if (JustReadCount <> 0) and (UnreadCount = 0){  } then
        Current := nil;
  end;

  procedure CorrectPosition;
  begin
    with Area do
    begin
      if Current = nil then
        Navigate({ }31, True);
      CurrentLetterChanged;
      Tree.OnChange(nil, nil);
    end;
  end;

begin
  HideHourGlass;

  Icon.Handle := LoadIcon(hInstance, 'Z_AREAF_ICON');
  ImageList.ResourceLoad(rtBitmap, 'AREAF_TREEIMAGES', clRed);

  UserItem.OnClick := AreasForm.UserItemClick;
  WindowListItem.OnClick := AreasForm.WindowListItemClick;
  AboutItem.OnClick := AreasForm.AboutItemClick;

  AreaLine := StatusBar.Panels[0];
  ConversationLine := StatusBar.Panels[1];
  LetterLine := StatusBar.Panels[2];

  InitViewer;

  with Area do
  if (UnreadOrJustReadCount <> 0) and (UnreadOrJustReadCount <> Count) then
    FShowKind := skUnreadsAndTheirParentsTree;

  UpdateOptions;
  UpdateCaption;
  UpdateAreaLine;

  InitPosition;
  UpdateTree;
  CorrectPosition;
end;

procedure TAreaForm.FormDestroy(Sender: TObject);

  procedure DoneViewer;
  begin
    {Timer.Enabled := False; ?}

    MessageLines.Free;
    MessageLines := nil{-  ScrollBoxResize,    };
  end;

begin
  Areas.Current := Area;
  if Assigned(AreasForm) then
    AreasForm.Navigate(+1);
{  Areas.VisibleSort;   }

  DoneViewer;

  Area.Close;
end;

procedure TAreaForm.TreeExitItemClick(Sender: TObject);
begin
  Close;
end;

procedure TAreaForm.FormStorageRestorePlacement(Sender: TObject);
var
  I: Integer;
  W: Integer;
begin
  with FormStorage do
  begin
    SpeedBar.RestoreLayout(IniFile);

{    with RegIniFile, HeaderControl do
      for I := 0 to Pred(2) do
      begin
        W := ReadInteger(Self.ClassName, Format(HeaderWidthKey, [I]), 0);
        if W = 0 then
          Break;
        SectionWidth[I] := W;
      end;}
  end;

  UpdateOptions;
end;

procedure TAreaForm.FormStorageSavePlacement(Sender: TObject);
var
  I: Integer;
begin
  with FormStorage do
  begin
    SpeedBar.SaveLayout(IniFile);

{    with IniFile, Header do
      for I := 0 to Pred(2) do
        WriteInteger(Self.ClassName, Format(HeaderWidthKey, [I]), SectionWidth[I]);}
  end;
end; 
 
procedure TAreaForm.UpdateOptions;
begin
  SpeedBarItem.Checked := SpeedBar.Visible;
  ShowHintItem.Checked := SpeedBar.ShowHint;
  StatusLineItem.Checked := StatusBar.Visible;

  with Area do
  begin
    SimpleTreeItem.Checked := ShowKind = skSimpleTree;
    UnreadsAndTheirParentsTreeItem.Checked := ShowKind = skUnreadsAndTheirParentsTree;
    ListItem.Checked := ShowKind = skList;

    SimpleTreeSpeedItem.Down := SimpleTreeItem.Checked;
    UnreadsAndTheirParentsTreeSpeedItem.Down := UnreadsAndTheirParentsTreeItem.Checked;
    ListSpeedItem.Down := ListItem.Checked;
  end;

  KludgesSpeedItem.Down := KludgesItem.Checked;
end;

procedure TAreaForm.ConfigureItemClick(Sender: TObject);
begin
  SpeedBar.Customize(0);
end;

procedure TAreaForm.ShowHintItemClick(Sender: TObject);
begin
  with SpeedBar do
    ShowHint := not ShowHint;

  UpdateOptions;
end;

procedure TAreaForm.HideSpeedBarClick(Sender: TObject);
begin
  SpeedBar.Hide;

  UpdateOptions;
end;

procedure TAreaForm.SpeedBarItemClick(Sender: TObject);
begin
  with SpeedBar do
    Visible := not Visible;

  UpdateOptions;
end;

procedure TAreaForm.StatusLineItemClick(Sender: TObject);
begin
  with StatusBar do
    Visible := not Visible;

  UpdateOptions;
end;

procedure TAreaForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;


procedure TAreaForm.StartStopUpdatingArea;
begin
  UpdateAreaLine;
end;

procedure TAreaForm.CMStartUpdatingArea;
begin
  if Msg.InfoPtr <> Area then
    Exit;

  StartStopUpdatingArea;
end;

procedure TAreaForm.CMStopUpdatingArea;

  procedure CheckShowMode;
  begin
    case ShowKind of
      skUnreadsAndTheirParentsTree:
        if Area.UnreadOrJustReadCount = 0
        then FShowKind := skSimpleTree
        else Exit;
      skSimpleTree:
        if Area.UnreadOrJustReadCount <> 0
        then FShowKind := skUnreadsAndTheirParentsTree
        else Exit;
      else
        Exit;
    end;
    UpdateOptions;
  end;

begin
  if Msg.InfoPtr <> Area then
    Exit;

  SetCurrent.Enabled := False{   DelayedCurrent,
           };

  StartStopUpdatingArea;

  CheckShowMode;
  UpdateTree;
end;

procedure TAreaForm.UpdateCaption;
begin
  with Area do
    Caption := Format('%s(%s)', [Comment, ID]);
end;

procedure TAreaForm.CMAreasChanged;
begin
  UpdateCaption;
end;

procedure TAreaForm.CMAreaCountsChange;
begin
  if Msg.InfoPtr <> Area then
    Exit;

  Tree.Invalidate;
(*  Outline.Invalidate{    ,  -,
       ,   Node.Text := '',  
     InvalidateCell};
*)
{  Outline.InvalidateDataItem(Area.Current);}
  UpdateAreaLine;
  UpdateConversationLine;
end;

{function TAreaForm.CountTotals;
var
  Letter: TLetter;
begin
  Result := False;

  Letter := Node.Data;
  if Assigned(Letter) then
    with Letter do
    begin
      Inc(TotalCount);
      if Unread then
        Inc(UnreadCount);
      if JustRead then
        Inc(JustReadCount);
    end;
end;}

procedure TAreaForm.UpdateConversationLine;

  function GetCurrentConversationInfo: string;
  var
    TreeNode: TTreeNode;
  begin
    with Tree do
    begin
      TreeNode := Selected;
      if not Assigned(TreeNode) then
      begin
        Result := '';
        Exit;
      end;

      TotalCount := 0;
      UnreadCount := 0;
      JustReadCount := 0;
      {TPAFOutlineNode(Items[Items[SelectedItem].TopItem]).Iterate(CountTotals);}
      Result := Format('%d , %d , %d ', [
        UnreadCount, JustReadCount, TotalCount]);
    end;
  end;

begin
  ConversationLine.Text := GetCurrentConversationInfo;
end;

procedure TAreaForm.CurrentLetterChanged;

  procedure Update;
  const
    NameAddressFormat = '%s  %s';
  var
    FormattedStrings: TFormattedStrings;
  begin
    ShowBuildLetterText;
    try
      with Area, Current, Disk^ do
      begin
        SubjectLabel.Caption := Subject;

        DateTimeWritten.Caption := DateTimeToStr(DateTime);

        FormattedStrings := TFormattedStrings.Create;
        with FormattedStrings do
          try
            if Present
            then ReadText(FormattedStrings)
            else Add(Format('[ #%d   ]', [Number]));

            LetterLine.Text := Format('%d ', [StrLen(GetText)]);

            with Viewer do
              AnalizeAndReFormat(KludgesItem.Checked, 0,
                Width-2{   }-17{ScrollBox.VertScrollBar.Width},
                Canvas,
                Disk);

            FromLabel.Caption := Format(NameAddressFormat , [From, AddrStr(FromAddr)]);
            ToLabel.Caption := Format(NameAddressFormat , [WhoTo, ''{AddrStr(ToAddr)}]);

            MessageLines.Assign(FormattedStrings);
          finally
            Free;
          end;
        UpdateViewerHeight;
      end;
    finally
      HideHourGlass;
    end;
  end;

begin
  if Area.Current = nil
  then ClearLetter
  else Update;

  UpdateConversationLine;
end;

procedure TAreaForm.CMCurrentLetterChanged;
begin
  CurrentLetterChanged;
end;

procedure TAreaForm.UpdateAreaLine;
begin
  AreaLine.Text := Area.GetInfo;
end;


procedure TAreaForm.TreeChange(Sender: TObject; ANode: TTreeNode);
var
  Node: TTreeNode;
begin
  with Tree, Area do
  begin
    Node := Selected;
    if not Assigned(Node) then
      Exit;

    DelayedCurrent := Node.Data;

    if not IncSearchResetBlocked then
      IncSearching := False;
  end;
end;

procedure TAreaForm.SwitchToTopEditorClick(Sender: TObject);
var
  I: Integer;
  Form: TForm;
begin
  with Screen do
    for I := 0 to Pred(FormCount) do
    begin
      Form := Forms[I];
      if (Form is TEditorForm) and (TEditorForm(Form).Area = Area) then
        ActivateWindow(Form.Handle);
    end;
end;

procedure TAreaForm.SwitchToAreasItemClick(Sender: TObject);
begin
  if Assigned(AreasForm)
  then ActivateWindow(AreasForm.Handle)
  else AreasForm := TAreasForm.Create(Application);
end;

procedure TAreaForm.HeaderSizing(Sender: TObject; ASection,
  AWidth: Integer);
begin
  Tree.Invalidate;
end;

procedure TAreaForm.CMAreaDestroyed;
begin
  if Msg.InfoPtr = Area then
    Close;
end;

procedure TAreaForm.FlushSetCurrentTimer;
begin
  with SetCurrent do
    if Enabled then
    begin
      Enabled := False;
      OnTimer(nil);
    end;
end;

procedure TAreaForm.AnyViewItemClick(Sender: TObject);
begin
  ShowKind := TShowKind((Sender as TComponent).Tag);
end;

procedure TAreaForm.AnyViewSpeedItemClick(Sender: TObject);
begin
{   
  ShowKind := TShowKind(Succ(Ord(ShowKind)) mod Succ(Ord(High(TShowKind))));}
  ShowKind := TShowKind((Sender as TComponent).Tag);
end;

function TAreaForm.ConversationContainUnreadOrJustReadLettersOrThis;
begin
  Result := Letter.UnreadOrJustRead or (Letter = InfoPtr);
end;

procedure TAreaForm.SelectCurrent;
var
  Letter: TLetter;
begin
  Letter := Area.Current;
  with Tree do
    if Assigned(Letter)
    then Selected := TTreeNode(Letter.InfoPtr)
    else Selected := Items[0];
end;

procedure TAreaForm.UpdateNodeStateByLetter;
begin
  with Letter do
    if Assigned(InfoPtr) then
      with TTreeNode(InfoPtr) do
        Bold := Unread or JustRead;
end;

procedure TAreaForm.UpdateTree;

  function AddLetterToTree(Node: TTreeNode; const S: string; Letter: TLetter): TTreeNode;
  begin
    Result := Tree.Items.AddChildObject(Node, S, Letter);

    if Assigned(Letter) then
      with Letter do
      begin
        InfoPtr := Result{,   };
        UpdateNodeStateByLetter(Letter);
      end;
  end;


  procedure List;
  var
    I: Integer;
    Letter: TLetter;
  begin
    with Tree.Items, Area do
      for I := 0 to Pred(Count) do
      begin
        Letter := TLetter(Items[I]);
        AddLetterToTree(nil, Letter.From, Letter);
      end;
  end;

var
  Filtered: TFilteredLetterList;

  procedure IncludeConversationStarts;
  var
    I: Integer;
    Letter: TLetter;
  begin
    with Area do
      for I := 0 to Pred(Count) do
      begin
        Letter := Items[I];
        with Letter do
          if IsConversationStart then
            Filtered.Add(Letter);
      end;
    Filtered.Sort;
  end;

  procedure InsertReplies(MustBeMarked: Boolean);

    procedure DoInsertReplies(Node: TTreeNode; Parent: TLetter);
    var
      I: Integer;
      Letter: TLetter;
    begin
      with Parent do
        with Replies do
          for I := 0 to Pred(Count) do
          begin
            Letter := Items[I];
            DoInsertReplies(
              AddLetterToTree(Node, Letter.From, Letter), Letter);
          end;
    end;

  var
    I: Integer;
    Letter: TLetter;
    Subject: string;
    Root, Node: TTreeNode;
  begin
    with Filtered do
    begin
      Subject := '';
      Root := Tree.Items. Add(nil, Caption);
      Node := nil;
      for I := 0 to Pred(Count) do
      begin
        Letter := Items[I];
        if MustBeMarked and not Letter.MarkedToInclude then
          Continue;

        if (Letter.Subject <> Subject) or (not Assigned(Node)) then
        begin
          Subject := Letter.Subject;
          Node := AddLetterToTree(Root, Subject, nil);
        end;

        DoInsertReplies(AddLetterToTree(Node, Letter.From, Letter), Letter);
      end;
    end;
    Root.Expand(False);
  end;

  procedure SimpleTree;
  begin
    Filtered := TFilteredLetterList.Create;
    try
      IncludeConversationStarts;
      InsertReplies(False);
    finally
      Filtered.Free;
    end;
  end;

  procedure UnreadsAndTheirParentsTree;

    procedure ClearMarks;
    var
      I: Integer;
    begin
      with Filtered do
        for I := 0 to Pred(Count) do
          TLetter(Items[I]).MarkedToInclude := False;
    end;

    procedure SetNewMarks;

      function MarkNeibours(J: Integer; const Same: string): Boolean;
      begin
        Result := True;

        with TLetter(Filtered.Items[J]) do
          if MarkedToInclude or (Subject <> Same)
          then Result := False
          else MarkedToInclude := True;
      end;

    var
      Same: string;
      I, J: Integer;
    begin
      with Filtered do
        for I := 0 to Pred(Count) do
          with TLetter(Items[I]) do
          begin
            if MarkedToInclude{   } then
              Continue;

            MarkedToInclude := IterateConversation(
              ConversationContainUnreadOrJustReadLettersOrThis, Area.Current);
            if MarkedToInclude then
            begin
              Same := Subject;
              for J := Pred(I) downto 0 do
                if not MarkNeibours(J, Same) then
                  Break;
              for J := Succ(I) to Pred(Count) do
                if not MarkNeibours(J, Same) then
                  Break;
            end;
          end;
    end;

  begin
    Filtered := TFilteredLetterList.Create;
    try
      IncludeConversationStarts;
      ClearMarks;
      SetNewMarks;

      InsertReplies(True);
    finally
      Filtered.Free;
    end;
  end;

begin
  ShowBuildTree;
  with Tree.Items do
  try
    BeginUpdate;
    Clear;
    case ShowKind of
      skSimpleTree:
        SimpleTree;
      skUnreadsAndTheirParentsTree:
        UnreadsAndTheirParentsTree;
      skList:
        List;
    end;
    SelectCurrent;
  finally
    EndUpdate;
    HideHourGlass;
  end;
end;

procedure TAreaForm.SetShowKind;
begin
  if FShowKind <> AShowKind then
  begin
    FShowKind := AShowKind;
    UpdateTree;
    UpdateConversationLine{  ,  ,   , 
         };
  end;

  UpdateOptions;
end;

function TAreaForm.IterateFunc;
var
  Letter: TLetter;
begin
  Letter := Node.Data;
  if Assigned(Letter)
  then Result := Letter.Unread{OrJustRead}
  else Result := False;
end;

function TAreaForm.HasUnreadDescendants;
begin
  Result := _TTreeNode(Node).Iterate(IterateFunc);
end;

procedure TAreaForm.AnyExpandCollapseItemClick(Sender: TObject);
var
  Node: TTreeNode;
begin
  with Tree do
  begin
    Node := Selected;
    if not Assigned(Node) then
      Exit;

    with Node do
      case (Sender as TMenuItem).Tag of
        0{+}: Expand(False);
        1{-}: Collapse(True);
        2{*}: Expand(True);
      end;
  end;
end;

procedure TAreaForm.ExpandAllOrCollapseAllItemClick(Sender: TObject);
var
  Node: TTreeNode;
begin
  with Tree do
  begin
    Node := Selected;
    if not Assigned(Node) then
      Exit;

    if Node.Data = nil{  subj,    current} then
    begin
      {    - }
      Navigate({}21, True);
      FlushSetCurrentTimer;
    end;

    ShowHourGlass;
{    LockWindowUpdate(Handle);}
{    Items.BeginUpdate; -   -    sb,      }
    try
      case (Sender as TMenuItem).Tag of
        3{Ctrl*}: FullExpand;
        4{Ctrl-}: FullCollapse;
      end;
    finally
{      LockWindowUpdate(0);}
{      Items.EndUpdate;}
      HideHourGlass;
    end;
    SelectCurrent;
  end;
end;

procedure TAreaForm.AnyNavigateItemClick(Sender: TObject);
var
  Code: Integer;
begin
  Code := (Sender as TComponent).Tag;

  Navigate(Code, False);
end;

procedure TAreaForm.Navigate;

  procedure ConditionalClose;
  begin
    if not EnteringArea and CloseQuery(True) then
      Close;
  end;

  function GetRootNode(Node: TTreeNode): TTreeNode;
  var
    NodeParent: TTreeNode;
  begin
    repeat
      NodeParent := Node.Parent;
      if (NodeParent = nil) or (NodeParent.Parent = nil) then
        Break;
      Node := NodeParent;
    until False;

    Result := Node;
  end;

  function NextPrev(Node: TTreeNode; Offset: Integer; MustBeUnread: Boolean): TTreeNode;
  var
    Letter: TLetter;
  begin
    Result := nil;

{    if EnteringArea then
      Dec(Index, Offset);}

    with Tree do
      repeat
        if Offset > 0
        then Node := Node.GetNext
        else Node := Node.GetPrev;

        if not Assigned(Node) then
        begin
          ConditionalClose;
          Break;
        end;

        Letter := Node.Data;
        if not Assigned(Letter) then
          Continue;

        if not MustBeUnread or Letter.UnreadOrJustRead then
        begin
          Result := Node;
          Break;
        end;
      until False;
  end;

  function NextPrevConversation(Node: TTreeNode;
    Offset: Integer; MustBeUnread: Boolean): TTreeNode;
  var
    SelectedRoot: TTreeNode;
    Letter: TLetter;
  begin
    Result := nil;
    with Tree.Items do
    begin
      SelectedRoot := GetRootNode(Node);
      repeat
        if Offset > 0
        then Node := Node.GetNext
        else Node := Node.GetPrev;

        if not Assigned(Node) then
        begin
          ConditionalClose;
          Break;
        end;

        if SelectedRoot <> GetRootNode(Node) then
        begin
          Letter := Node.Data;
          if Letter = nil then
            Continue;

          if not MustBeUnread or Letter.UnreadOrJustRead then
          begin
            Result := Node;
            Break;
          end;
        end;
      until False;
    end;
  end;

var
  Node: TTreeNode;
begin
  with Tree do
  begin
    Node := Selected;
    if not Assigned(Node) then
    begin
      ConditionalClose;
      Exit;
    end;

    if ActiveControl = Viewer then
      with Area do
        if Current <> nil then
        begin
          Current.MarkAsRead;
          UpdateNodeStateByLetter(Current);
        end;

    case Code of
      { }29,
      { }31,
      {   }49,
      {   }51:
        if Area.UnreadOrJustReadCount = 0{   ,
            ,   ,     ?[]} then
        begin
          ConditionalClose;
          Exit;
        end;
    end;

    case Code of
      {  }0:
        Node := GetRootNode(Node);
      {  }9:
        Node := Node.Parent;
      {  }11:
        Node := Node.GetFirstChild;
      {} 19,
      {}21:
        Node := NextPrev(Node, Code-20, False);
      { }29,
      { }31:
        Node := NextPrev(Node, Code-30, True);
      { }39,
      { }41:
        Node := NextPrevConversation(Node, Code-40, False);
      {   }49,
      {   }51:
        Node := NextPrevConversation(Node, Code-50, True);
      {    }59:
        Node := Node.GetPrevSibling;
      {    }61:
        Node := Node.GetNextSibling;
    end;

    if Assigned(Node) then
    begin
      Selected := Node;
      if Assigned(Node.Data) and TLetter(Node.Data).Unread then
        Node.Expand(True);

      DelayedCurrent := Node.Data;
    end;
  end;
end;

function TAreaForm.GetDelayedCurrent;
begin
  Result := Area.Current;
end;

procedure TAreaForm.SetDelayedCurrent;
begin
  FDelayedCurrent := ADelayedCurrent;

  SetCurrent.Enabled := False;
  SetCurrent.Enabled := True;
end;

procedure TAreaForm.SetCurrentTimer(Sender: TObject);
begin
  SetCurrent.Enabled := False;
  Area.Current := FDelayedCurrent;
  UpdateConversationLine{,    ,
     -  __    SUBJECT};
end;

procedure TAreaForm.SetIncSearching;
begin
  FIncSearching := AIncSearching;

  if FIncSearching
  then
  begin
    StatusBar.SimpleText := Format(': %s' , [IncSearchedStr]);
    StatusBar.SimplePanel := True;
  end
  else
    StatusBar.SimplePanel := False;
end;

procedure TAreaForm.SetIncSearchedStr;
var
  IncSearchCount: Integer;
  Node: TTreeNode;
  Found: Boolean;
  S: string;
begin
  S := AnsiUpperCase(AIncSearchedStr);

  IncSearchCount := 0;
  ShowHourGlass;
  try
    with Tree do
    begin
      Node := FIncSearchStartNode;
      while Assigned(Node) do
      begin
        Found := S = '';

        if not Found then
          if Node.Data = nil
          then
            {Found := Pos(S, AnsiUpperCase(Node.Text)) <> 0   - }
          else
            with TLetter(Node.Data) do
              Found :=
                (Pos(S, AnsiUpperCase(Subject)) <> 0) or
                (Pos(S, AnsiUpperCase(From)) <> 0);
        if Found then
          if IncSearchCount = FIncSearchCount
          then
          begin
            FIncSearchedStr := AIncSearchedStr;

            DoFind.Enabled := False;
            DoFindNode := Node;
            DoFind.Enabled := True;

            IncSearching := True;
            Exit;
          end
          else
            Inc(IncSearchCount);

        Node := Node.GetNext;
      end;
    end;
  finally
    HideHourGlass;
  end;
  MessageBeep(0);
end;


procedure TAreaForm.DoFindTimer(Sender: TObject);
begin
  DoFind.Enabled := False;

  IncSearchResetBlocked := True;
  Tree.Selected := DoFindNode;
  IncSearchResetBlocked := False;
end;

procedure TAreaForm.TreeKeyPress(Sender: TObject; var Key: Char);
begin
  if
    (Tree.Selected = nil){ or (Key = ^M)} or
    not (AnsiUpperCase(Key)[1] in ['0'..'9', 'A'..'Z', ''..'']) then
    Exit;

  if not IncSearching then
  begin
    FIncSearchCount := 0;
    FIncSearchStartNode := Tree.Selected;
  end;
  if Key = SearchAgain
  then
  begin
    if IncSearching then
      Inc(FIncSearchCount);

    IncSearchedStr := IncSearchedStr;
  end
  else
  begin
    if not IncSearching then
      FIncSearchedStr := '';

    if Key = BackSpace
    then IncSearchedStr := Copy(IncSearchedStr, 1, Pred(Length(IncSearchedStr)))
    else IncSearchedStr := IncSearchedStr+Key;
  end;

  Key := #0;
end;

procedure TAreaForm.FormDeactivate(Sender: TObject);
begin
  IncSearching := False;
end;

procedure TAreaForm.AnyLetterItemClick(Sender: TObject);
var
  Action: TEditorAction;
begin
  FlushSetCurrentTimer;

  if Sender is TMenuItem
  then Action := TEditorAction(TMenuItem(Sender).Tag)
  else Action := TEditorAction((Sender as TComponent).Tag);

  if Action <> eaNew then
    with Area do
      begin
        if (Current = nil) or (not Current.Present) then
          Exit;
        Current.MarkAsRead;
      end;

  if Action in [eaNew, eaEdit, eaReply, eaComment] then{!}
    TEditorForm.Create(Area, Self, Action);
end;

function TAreaForm.CloseQuery;
begin
  HideHourGlass{    };

  Result := True;

  if GlobalCanClose then
    Exit;

  with Area do
    if UnreadCount = 0
    then
      if FromNavigate
      then
        Result := MessageDlg(Format('   %s(%s)?', [Comment, ID]),
          mtConfirmation, [mbOK, mbCancel], 0) <> mrCancel
      else
        {}
    else
      case MessageDlg(
        Format('   %s(%s).'^M+
          '   ,  ?',
          [Comment, ID]),
        mtConfirmation, [mbYes, mbNo, mbCancel], 0) of
        mrYes:
        begin
          ShowHourGlass;
          try
            Area.MarkAllAsRead;
          finally
            HideHourGlass;
          end;
        end;
        mrCancel: Result := False;
      end;

  GlobalCanClose := Result;
end;

procedure TAreaForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := not SomebodyObject(CM_AreaDontWantToClose, Area) and CloseQuery(False);
end;

procedure TAreaForm.DeleteItemClick(Sender: TObject);
var
  SavedCurrent: TLetter;
begin
  with Area do
  begin
    FlushSetCurrentTimer;

    if (Current = nil) or not Current.Present then
      Exit;

    if MessageDlg(' ?', mtConfirmation, [mbYes, mbNo], 0) <> mrYes then
      Exit;

    SavedCurrent := Current;
    try
      VisualDelete(SavedCurrent, TTreeNode(SavedCurrent.InfoPtr).Parent.Data)
      {   current [:=nil],    };
      SavedCurrent.Delete;
    finally
      SavedCurrent.Free;
    end;
  end;
end;

procedure TAreaForm.ViewerDrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
var
  S: string;
  tk: TTextKind;
begin
  with Viewer.Canvas, Rect do
    if MessageLines.Count = 0
    then
      {FillRect(Rect)   ?}
    else
    begin
      S := MessageLines[Row];
(*      tk := GetTextKind(S);
      if tk = tkKludge then
        Delete(S, 1, 1)
        {S[1] := '.'};*)

      tk := GetTextKind(S);
      if IsKludge(S){tkKludge  ,    SEEN-BY,   ^A} then
        Delete(S, 1, 1);

      {Font := EnvDialog.Fonts[tk];}
      {Brush.Color := EnvDialog.Colors[tk];}

      Font := Viewer.Font;
      Font.Color := tkColors[tk];
      Brush := Viewer.Brush;

      Inc(Bottom);
      FillRect(Rect);
      Inc(Left, 2);
      TextRect(Rect, Left, Top, S);
    end;
end;

procedure TAreaForm.KludgesItemClick(Sender: TObject);
begin
  with KludgesItem do
    Checked := not Checked;
  UpdateOptions;

  CurrentLetterChanged;
end;

procedure TAreaForm.KludgesSpeedItemClick(Sender: TObject);
begin
  KludgesItem.Checked := KludgesSpeedItem.Down;

  CurrentLetterChanged;
end;

procedure TAreaForm.ViewerKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  WParam: Word;
begin
  if Shift <> [] then Exit;
  case Key of
    VK_UP: WParam := SB_LINEUP;
    VK_DOWN: WParam := SB_LINEDOWN;
    VK_PRIOR: WParam := SB_PAGEUP;
    VK_NEXT: WParam := SB_PAGEDOWN;
    VK_HOME: WParam := SB_TOP;
    VK_END: WParam := SB_BOTTOM;
    else Exit;
  end;
  Key := 0{     };
  ScrollBox.Perform(WM_VSCROLL, WParam, 0);
end;

procedure TAreaForm.LetterBrowseSwitchItemClick(Sender: TObject);
begin
  if ActiveControl = Tree
  then
  begin
    FlushSetCurrentTimer;
    if Area.Current = nil then
      with Tree do
        if Selected <> nil then
          if HasUnreadDescendants(Selected)
          then Navigate({ }31, True)
          else Navigate({  }11, True);

    Viewer.SetFocus;
  end
  else
    Tree.SetFocus;
end;

procedure TAreaForm.SetViewerWidth;
begin
  if MessageLines <> nil then
  begin
    if Viewer.Width = AViewerWidth then
      Exit;
    Viewer.Width := AViewerWidth;

    CurrentLetterChanged;
  end;
end;

procedure TAreaForm.UpdateViewerWidth;
begin
  ViewerWidth := ScrollBox.Width;
end;

procedure TAreaForm.ScrollBoxResize(Sender: TObject);
begin
  UpdateViewerWidth;
end;

procedure TAreaForm.TreeGetImageIndex(Sender: TObject; Node: TTreeNode);
var
  NewIndex: Integer;
begin
  with Node do
    if Parent <> nil then
    begin
      if Data = nil{}
      then
        NewIndex := 1
      else
        with TLetter(Data) do
        begin
          NewIndex := 3;
          if Unread then
            Inc(NewIndex, 2);
        end;
      if not Expanded{collapsed} and HasUnreadDescendants(Node) then
        Inc(NewIndex);
      ImageIndex := NewIndex;
    end;
end;

procedure TAreaForm.TreeGetSelectedIndex(Sender: TObject; Node: TTreeNode);
begin
  with Node do
    SelectedIndex := ImageIndex;
end;

procedure TAreaForm.FormActivate(Sender: TObject);
begin
  Application.OnHint := ApplicationHint;
end;

procedure TAreaForm.ApplicationHint;
begin
  StatusBar.SimpleText := Application.Hint;
  StatusBar.SimplePanel := StatusBar.SimpleText <> '';
end;

end.
