unit Tokens;

interface

const
  TokenStartChar = '@';

  MinTokenWidth = 5{TName};
  MaxTokenWidth = 6{CFName};

  TokenNames: array[-2..23] of PChar = (
    'Quote'      {Inserts a quote of the original message},
    'Position'   {Specifies the starting line for the editor cursor},

    'CAddr'      {Current user address},
    'CFName'     {Current user first name},
    'CLName'     {Current user last name},
    'CName'      {Current user name},
    'CDate'      {Current date},
    'CTime'      {Current time},
    'CDesc'      {Current area description},
    'CEcho'      {Current echoid},

    'OAddr'      {Original address},
    'OFName'     {Original first name},
    'OLName'     {Original last name},
    'OName'      {Original name},
    'ODate'      {Original date},
    'OTime'      {Original time},
    'ODesc'      {Original area description if moved, else current},
    'OEcho'      {Original echoid if moved, otherwise current},

    'DAddr'      {Destination address},
    'DFName'     {Destination first name},
    'DLName'     {Destination last name},
    'DName'      {Destination name},

    'TAddr'      {Destination to address},
    'TFName'     {Destination to first name},
    'TLName'     {Destination to last name},
    'TName'      {Destination to name}
    );

implementation

end.
