unit TreeHU;

interface

uses
  ComCtrls;

type
  TTreeNodeIteratorFunc = function(Node: TTreeNode): Boolean of object;

  _TTreeNode = class(TTreeNode)
    function Iterate(Func: TTreeNodeIteratorFunc): Boolean;
  end;

implementation

function _TTreeNode.Iterate;
var
  Node: TTreeNode;
begin
  Result := False;
  
  Node := GetNext;
  while Assigned(Node) and Node.HasAsParent(Self) do
  begin
    Result := Func(Node);
    if Result then
      Break;
    Node := Node.GetNext;
  end;
end;

end.
