unit UserF;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Tabs, ExtCtrls, Menus;

type
  TUserForm = class(TForm)
    Notebook: TNotebook;
    TabSet: TTabSet;
    Label1: TLabel;
    NameEdit: TEdit;
    Label2: TLabel;
    MainAddressEdit: TEdit;
    Label3: TLabel;
    AKAsMemo: TMemo;
    NewLetterTemplateMemo: TMemo;
    HiddenFormPopupMenu: TPopupMenu;
    NextPageItem: TMenuItem;
    PrevPageItem: TMenuItem;
    TokensBitBtn: TBitBtn;
    TokensPopupMenu: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    ID1: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    Label4: TLabel;
    QuoteReplyTemplateMemo: TMemo;
    BitBtn1: TBitBtn;
    N9: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    N15: TMenuItem;
    N16: TMenuItem;
    N17: TMenuItem;
    N18: TMenuItem;
    N19: TMenuItem;
    N20: TMenuItem;
    ID2: TMenuItem;
    N21: TMenuItem;
    N22: TMenuItem;
    N23: TMenuItem;
    N24: TMenuItem;
    N25: TMenuItem;
    N30: TMenuItem;
    N31: TMenuItem;
    N32: TMenuItem;
    N33: TMenuItem;
    N34: TMenuItem;
    N26: TMenuItem;
    N27: TMenuItem;
    N28: TMenuItem;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure TabSetClick(Sender: TObject);
    procedure NextPageItemClick(Sender: TObject);
    procedure TokensBitBtnClick(Sender: TObject);
    procedure AnyTokenClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

uses
  Tokens;

procedure TUserForm.FormCreate(Sender: TObject);
begin
  TabSet.Tabs := Notebook.Pages;
end;

procedure TUserForm.TabSetClick(Sender: TObject);
begin
  Notebook.PageIndex := TabSet.TabIndex;
end;

procedure TUserForm.NextPageItemClick(Sender: TObject);
begin
  with TabSet, Tabs do
    TabIndex := (TabIndex+(Sender as TMenuItem).Tag+Count) mod Count;
end;

procedure TUserForm.TokensBitBtnClick(Sender: TObject);
begin
  with TokensBitBtn, ClientToScreen(Point(0, Height)) do
    TokensPopupMenu.Popup(X, Y);
end;

procedure TUserForm.AnyTokenClick(Sender: TObject);
var
  Memo: TMemo;
  TokenNum: Integer;
begin
  case NoteBook.PageIndex of
    1: Memo := NewLetterTemplateMemo;
    2: Memo := QuoteReplyTemplateMemo;
  end;

  with Memo do
  begin
    TokenNum := (Sender as TMenuItem).Tag;
    SetSelTextBuf(TokenStartChar);
    SetSelTextBuf(TokenNames[TokenNum]);
    if TokenNum < 2
    then SetSelTextBuf(^M^J)
    else SetSelTextBuf(' ');

    SetFocus;
  end;
end;

procedure TUserForm.FormActivate(Sender: TObject);
var
  I: Integer;
  Component: TComponent;
begin
  for I := 0 to Pred(ComponentCount) do
  begin
    Component := Components[I];
    if Component is TMemo then
      TMemo(Component).SelStart := 0;
  end;
end;

end.

